> For the complete documentation index, see [llms.txt](https://developers.pipelinersales.com/api-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.pipelinersales.com/api-docs/core-api-concepts/pagination.md).

# Pagination

Coevera sends a maximum of **100** (Default: **30**) records per request. The limit can be changed by [**API parameter** ](/api-docs/core-api-concepts/api-parameters.md)`first`

Pagination is available after the successful call of all `.list` Endpoints. Then API returns the following data

```json
{
	"success": true,
	"total": 107,
	"page_info": {
		"start_cursor": "WyIwMzU4NmNhMS1mMmJjLTQ2MDctYWE3Ni1jYWYyYTNlOWQ5ODciXQ==",
		"end_cursor": "WyI0MGUxMGE1MC00ZTYxLTQ0M2YtYmUzOC0xNmNjMzQ5NTM2NGUiXQ==",
		"has_previous_page": false,
		"has_next_page": true
	},
	"data": [...]
}
```

#### Using Cursor for pagination

To retrieve all data, it is recommended to use `end_cursor` with combination of [**API Parameter**](/api-docs/core-api-concepts/api-parameters.md) `after.` Iterate through the list, until the `has_next_page` is `false`

```
{{baseUrl}}/entities/Opportunities?after=WyI0MGUxMGE1MC00ZTYxLTQ0M2YtYmUzOC0xNmNjMzQ5NTM2NGUiXQ==
```

**Pagination done programmatically**

```python
while has_next_page, do get_records(after=end_cursor)
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.pipelinersales.com/api-docs/core-api-concepts/pagination.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
